RuntimeSingleton (Velocity 1.7 API)
Keywords: org.apache.velocity.runtime.RuntimeSingleton class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.velocity.runtime
Class RuntimeSingleton

    java.lang.Object
      org.apache.velocity.runtime.RuntimeSingleton

All Implemented Interfaces:
  RuntimeConstants

public class RuntimeSingleton
extends Object
implements RuntimeConstants

This is the Runtime system for Velocity. It is the single access point for all functionality in Velocity. It adheres to the mediator pattern and is the only structure that developers need to be familiar with in order to get Velocity to perform. The Runtime will also cooperate with external systems like Turbine. Runtime properties can set and then the Runtime is initialized. Turbine for example knows where the templates are to be loaded from, and where the velocity log file should be placed. So in the case of Velocity cooperating with Turbine the code might look something like the following:

     RuntimeSingleton.setProperty(RuntimeConstants.FILE_RESOURCE_LOADER_PATH, templatePath);
     RuntimeSingleton.setProperty(RuntimeConstants.RUNTIME_LOG, pathToVelocityLog);
     RuntimeSingleton.init();

     -----------------------------------------------------------------------
     N O T E S  O N  R U N T I M E  I N I T I A L I Z A T I O N
     -----------------------------------------------------------------------
     RuntimeSingleton.init()

     If Runtime.init() is called by itself the Runtime will
     initialize with a set of default values.
     -----------------------------------------------------------------------
     RuntimeSingleton.init(String/Properties)

     In this case the default velocity properties are layed down
     first to provide a solid base, then any properties provided
     in the given properties object will override the corresponding
     default property.
     -----------------------------------------------------------------------

Version:
  $Id: RuntimeSingleton.java 898050 2010-01-11 20:15:31Z nbubna $
Author:
  Jason van Zyl, Jeff Bowden, Geir Magusson Jr., Daniel Rall
See Also:
  `RuntimeInstance`

Field Summary

Fields inherited from interface org.apache.velocity.runtime.RuntimeConstants
`COUNTER_INITIAL_VALUE, COUNTER_NAME, DEBUG_PREFIX, DEFAULT_RUNTIME_DIRECTIVES, DEFAULT_RUNTIME_PROPERTIES, DEFINE_DIRECTIVE_MAXDEPTH, DIRECTIVE_IF_TOSTRING_NULLCHECK, ENCODING_DEFAULT, ERROR_PREFIX, ERRORMSG_END, ERRORMSG_START, EVALUATE_CONTEXT_CLASS, EVENTHANDLER_INCLUDE, EVENTHANDLER_INVALIDREFERENCES, EVENTHANDLER_METHODEXCEPTION, EVENTHANDLER_NULLSET, EVENTHANDLER_REFERENCEINSERTION, FILE_RESOURCE_LOADER_CACHE, FILE_RESOURCE_LOADER_PATH, HAS_NEXT_NAME, INFO_PREFIX, INPUT_ENCODING, INTERPOLATE_STRINGLITERALS, INTROSPECTOR_RESTRICT_CLASSES, INTROSPECTOR_RESTRICT_PACKAGES, MAX_NUMBER_LOOPS, NUMBER_OF_PARSERS, OUTPUT_ENCODING, PARSE_DIRECTIVE_MAXDEPTH, PARSER_POOL_CLASS, PARSER_POOL_SIZE, PROVIDE_SCOPE_CONTROL, RESOURCE_LOADER, RESOURCE_MANAGER_CACHE_CLASS, RESOURCE_MANAGER_CLASS, RESOURCE_MANAGER_DEFAULTCACHE_SIZE, RESOURCE_MANAGER_LOGWHENFOUND, RUNTIME_LOG, RUNTIME_LOG_ERROR_STACKTRACE, RUNTIME_LOG_INFO_STACKTRACE, RUNTIME_LOG_LOGSYSTEM, RUNTIME_LOG_LOGSYSTEM_CLASS, RUNTIME_LOG_REFERENCE_LOG_INVALID, RUNTIME_LOG_WARN_STACKTRACE, RUNTIME_REFERENCES_STRICT, RUNTIME_REFERENCES_STRICT_ESCAPE, SET_NULL_ALLOWED, SKIP_INVALID_ITERATOR, STRICT_MATH, TRACE_PREFIX, UBERSPECT_CLASSNAME, UNKNOWN_PREFIX, VM_ARGUMENTS_STRICT, VM_BODY_REFERENCE, VM_CONTEXT_LOCALSCOPE, VM_LIBRARY, VM_LIBRARY_AUTORELOAD, VM_LIBRARY_DEFAULT, VM_MAX_DEPTH, VM_MESSAGES_ON, VM_PERM_ALLOW_INLINE, VM_PERM_ALLOW_INLINE_REPLACE_GLOBAL, VM_PERM_INLINE_LOCAL, WARN_PREFIX`

Constructor Summary
`RuntimeSingleton()`

Method Summary
`static void` | `addProperty(String key, Object value)` Add a property to the configuration.
`static boolean` | `addVelocimacro(String name, Node macro, String[] argArray, String sourceTemplate)` Adds a new Velocimacro.
`static boolean` | `addVelocimacro(String name, String macro, String[] argArray, String sourceTemplate)` Deprecated. Use addVelocimacro(String, Node, String[], String) instead
`static void` | `clearProperty(String key)` Clear the values pertaining to a particular property.
`static void` | `debug(Object message)` Deprecated. Use getLog() and call debug() on it.
`static boolean` | `dumpVMNamespace(String namespace)` tells the vmFactory to dump the specified namespace.
`static void` | `error(Object message)` Deprecated. Use getLog() and call error() on it.
`static Object` | `getApplicationAttribute(Object key)` Gets the application attribute for the given key
`static boolean` | `getBoolean(String key, boolean def)` Boolean property accessor method to hide the configuration implementation.
`static ExtendedProperties` | `getConfiguration()` Return the velocity runtime configuration object.
`static ContentResource` | `getContent(String name)` Returns a static content resource from the resource manager.
`static ContentResource` | `getContent(String name, String encoding)` Returns a static content resource from the resource manager.
`EventCartridge` | `getEventCartridge()` Returns the event handlers for the application.
`static int` | `getInt(String key)` Int property accessor method to hide the configuration implementation.
`static int` | `getInt(String key, int defaultValue)` Int property accessor method to hide the configuration implementation.
`static Introspector` | `getIntrospector()` Return the Introspector for this RuntimeInstance
`static String` | `getLoaderNameForResource(String resourceName)` Determines is a template exists, and returns name of the loader that provides it.
`static Log` | `getLog()` Returns a convenient Log instance that wraps the current LogChute.
`static Object` | `getProperty(String key)` Allows an external caller to get a property.
`static RuntimeInstance` | `getRuntimeInstance()` Deprecated. Use getRuntimeServices() instead.
`static RuntimeServices` | `getRuntimeServices()` Returns the RuntimeServices Instance used by this wrapper.
`static String` | `getString(String key)` String property accessor method to hide the configuration implementation
`static String` | `getString(String key, String defaultValue)` String property accessor method with default to hide the configuration implementation.
`static Template` | `getTemplate(String name)` Returns a `Template` from the resource manager.
`static Template` | `getTemplate(String name, String encoding)` Returns a `Template` from the resource manager
`static Uberspect` | `getUberspect()` Returns the Uberspect object for this Instance.
`static Directive` | `getVelocimacro(String vmName, String templateName)` Returns the appropriate VelocimacroProxy object if strVMname is a valid current Velocimacro.
`static void` | `info(Object message)` Deprecated. Use getLog() and call info() on it.
`static void` | `init()` This is the primary initialization method in the Velocity Runtime.
`static void` | `init(Properties p)` Initialize the Velocity Runtime with a Properties object.
`static void` | `init(String configurationFile)` Initialize the Velocity Runtime with the name of ExtendedProperties object.
`static boolean` | `isInitialized()` Returns true if the RuntimeInstance has been successfully initialized.
`static boolean` | `isVelocimacro(String vmName, String templateName)` Checks to see if a VM exists
`static void` | `loadDirective(String directiveClass)` Instantiates and loads the directive with some basic checks.
`static SimpleNode` | `parse(Reader reader, String templateName)` Parse the input and return the root of AST node structure.
`static SimpleNode` | `parse(Reader reader, String templateName, boolean dumpNamespace)` Parse the input and return the root of the AST node structure.
`static void` | `removeDirective(String name)` Remove a directive.
`static void` | `setConfiguration(ExtendedProperties configuration)` Allow an external system to set an ExtendedProperties object to use.
`static void` | `setProperty(String key, Object value)` Allows an external system to set a property in the Velocity Runtime.
`static void` | `warn(Object message)` Deprecated. Use getLog() and call warn() on it.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### RuntimeSingleton

    public RuntimeSingleton()

Method Detail

### init

    public static void init()

  This is the primary initialization method in the Velocity Runtime. The systems that are setup/initialized here are as follows:
  - Logging System
  - ResourceManager
  - Event Handlers
  - Parser Pool
  - Global Cache
  - Static Content Include System
  - Velocimacro System

  See Also:
    `RuntimeInstance.init()`

### isInitialized

    public static boolean isInitialized()

  Returns true if the RuntimeInstance has been successfully initialized.

  Returns:
    True if the RuntimeInstance has been successfully initialized.
  Since:
    1.5
  See Also:
    `RuntimeInstance.isInitialized()`

### getRuntimeServices

    public static RuntimeServices getRuntimeServices()

  Returns the RuntimeServices Instance used by this wrapper.

  Returns:
    The RuntimeServices Instance used by this wrapper.

### setProperty

    public static void setProperty(String key,
                                   Object value)

  Allows an external system to set a property in the Velocity Runtime.

  Parameters:
    `key` - property key
    `value` - property value
  See Also:
    `RuntimeInstance.setProperty(String, Object)`

### setConfiguration

    public static void setConfiguration(ExtendedProperties configuration)

  Allow an external system to set an ExtendedProperties object to use. This is useful where the external system also uses the ExtendedProperties class and the velocity configuration is a subset of parent application's configuration. This is the case with Turbine.

  Parameters:
    `configuration` -
  See Also:
    `RuntimeInstance.setConfiguration(ExtendedProperties)`

### addProperty

    public static void addProperty(String key,
                                   Object value)

  Add a property to the configuration. If it already exists then the value stated here will be added to the configuration entry. For example, if resource.loader = file is already present in the configuration and you addProperty("resource.loader", "classpath") Then you will end up with a Vector like the following: ["file", "classpath"]

  Parameters:
    `key` -
    `value` -
  See Also:
    `RuntimeInstance.addProperty(String, Object)`

### clearProperty

    public static void clearProperty(String key)

  Clear the values pertaining to a particular property.

  Parameters:
    `key` - of property to clear
  See Also:
    `RuntimeInstance.clearProperty(String)`

### getProperty

    public static Object getProperty(String key)

  Allows an external caller to get a property. The calling routine is required to know the type, as this routine will return an Object, as that is what properties can be.

  Parameters:
    `key` - property to return
  Returns:
    Value of the property or null if it does not exist.
  See Also:
    `RuntimeInstance.getProperty(String)`

### init

    public static void init(Properties p)

  Initialize the Velocity Runtime with a Properties object.

  Parameters:
    `p` -
  See Also:
    `RuntimeInstance.init(Properties)`

### init

    public static void init(String configurationFile)

  Initialize the Velocity Runtime with the name of ExtendedProperties object.

  Parameters:
    `configurationFile` -
  See Also:
    `RuntimeInstance.init(String)`

### parse

    public static SimpleNode parse(Reader reader,
                                   String templateName)
                            throws ParseException

  Parse the input and return the root of AST node structure.
  In the event that it runs out of parsers in the pool, it will create and let them be GC'd dynamically, logging that it has to do that. This is considered an exceptional condition. It is expected that the user will set the PARSER_POOL_SIZE property appropriately for their application. We will revisit this.

  Parameters:
    `reader` - Reader retrieved by a resource loader
    `templateName` - name of the template being parsed
  Returns:
    A root node representing the template as an AST tree.
  Throws:
    `ParseException` - When the template could not be parsed.
  See Also:
    `RuntimeInstance.parse(Reader, String)`

### parse

    public static SimpleNode parse(Reader reader,
                                   String templateName,
                                   boolean dumpNamespace)
                            throws ParseException

  Parse the input and return the root of the AST node structure.

  Parameters:
    `reader` - Reader retrieved by a resource loader
    `templateName` - name of the template being parsed
    `dumpNamespace` - flag to dump the Velocimacro namespace for this template
  Returns:
    A root node representing the template as an AST tree.
  Throws:
    `ParseException` - When the template could not be parsed.
  See Also:
    `RuntimeInstance.parse(Reader, String, boolean)`

### getTemplate

    public static Template getTemplate(String name)
                                throws ResourceNotFoundException,
                                       ParseErrorException

  Returns a `Template` from the resource manager. This method assumes that the character encoding of the template is set by the `input.encoding` property. The default is "ISO-8859-1"

  Parameters:
    `name` - The file name of the desired template.
  Returns:
    The template.
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.
  See Also:
    `RuntimeInstance.getTemplate(String)`

### getTemplate

    public static Template getTemplate(String name,
                                       String encoding)
                                throws ResourceNotFoundException,
                                       ParseErrorException

  Returns a `Template` from the resource manager

  Parameters:
    `name` - The name of the desired template.
    `encoding` - Character encoding of the template
  Returns:
    The template.
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.
  See Also:
    `RuntimeInstance.getTemplate(String, String)`

### getContent

    public static ContentResource getContent(String name)
                                      throws ResourceNotFoundException,
                                             ParseErrorException

  Returns a static content resource from the resource manager. Uses the current value if INPUT_ENCODING as the character encoding.

  Parameters:
    `name` - Name of content resource to get
  Returns:
    parsed ContentResource object ready for use
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - When the template could not be parsed.
  See Also:
    `RuntimeInstance.getContent(String)`

### getContent

    public static ContentResource getContent(String name,
                                             String encoding)
                                      throws ResourceNotFoundException,
                                             ParseErrorException

  Returns a static content resource from the resource manager.

  Parameters:
    `name` - Name of content resource to get
    `encoding` - Character encoding to use
  Returns:
    parsed ContentResource object ready for use
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - When the template could not be parsed.
  See Also:
    `RuntimeInstance.getContent(String, String)`

### getLoaderNameForResource

    public static String getLoaderNameForResource(String resourceName)

  Determines is a template exists, and returns name of the loader that provides it. This is a slightly less hokey way to support the Velocity.templateExists() utility method, which was broken when per-template encoding was introduced. We can revisit this.

  Parameters:
    `resourceName` - Name of template or content resource
  Returns:
    class name of loader than can provide it
  See Also:
    `RuntimeInstance.getLoaderNameForResource(String)`

### getLog

    public static Log getLog()

  Returns a convenient Log instance that wraps the current LogChute.

  Returns:
    A convenience Log instance that wraps the current LogChute.
  Since:
    1.5
  See Also:
    `RuntimeInstance.getLog()`

### warn

    public static void warn(Object message)

  Deprecated. Use getLog() and call warn() on it.

  Parameters:
    `message` - The message to log.
  See Also:
    `Log.warn(Object)`

### info

    public static void info(Object message)

  Deprecated. Use getLog() and call info() on it.

  Parameters:
    `message` - The message to log.
  See Also:
    `Log.info(Object)`

### error

    public static void error(Object message)

  Deprecated. Use getLog() and call error() on it.

  Parameters:
    `message` - The message to log.
  See Also:
    `Log.error(Object)`

### debug

    public static void debug(Object message)

  Deprecated. Use getLog() and call debug() on it.

  Parameters:
    `message` - The message to log.
  See Also:
    `Log.debug(Object)`

### getString

    public static String getString(String key,
                                   String defaultValue)

  String property accessor method with default to hide the configuration implementation.

  Parameters:
    `key` - property key
    `defaultValue` - default value to return if key not found in resource manager.
  Returns:
    value of key or default
  See Also:
    `RuntimeInstance.getString(String, String)`

### getVelocimacro

    public static Directive getVelocimacro(String vmName,
                                           String templateName)

  Returns the appropriate VelocimacroProxy object if strVMname is a valid current Velocimacro.

  Parameters:
    `vmName` - Name of velocimacro requested
    `templateName` - Name of the template that contains the velocimacro.
  Returns:
    The requested VelocimacroProxy.
  See Also:
    `RuntimeInstance.getVelocimacro(String, String)`

### addVelocimacro

    public static boolean addVelocimacro(String name,
                                         Node macro,
                                         String[] argArray,
                                         String sourceTemplate)

  Adds a new Velocimacro. Usually called by Macro only while parsing.

  Parameters:
    `name` - Name of a new velocimacro.
    `macro` - root AST node of the parsed macro
    `argArray` - Array of strings, containing the #macro() arguments. the 0th argument is the name.
    `sourceTemplate` - The template from which the macro is requested.
  Returns:
    boolean True if added, false if rejected for some reason (either parameters or permission settings)
  Since:
    1.6
  See Also:
    `RuntimeInstance.addVelocimacro(String, Node, String[], String)`

### addVelocimacro

    public static boolean addVelocimacro(String name,
                                         String macro,
                                         String[] argArray,
                                         String sourceTemplate)

  Deprecated. Use addVelocimacro(String, Node, String[], String) instead

  Adds a new Velocimacro. Usually called by Macro only while parsing.

  Parameters:
    `name` - Name of velocimacro
    `macro` - String form of macro body
    `argArray` - Array of strings, containing the #macro() arguments. the 0th is the name.
    `sourceTemplate` - Name of the template that contains the velocimacro.
  Returns:
    True if added, false if rejected for some reason (either parameters or permission settings)
  See Also:
    `RuntimeInstance.addVelocimacro(String, String, String[], String)`

### isVelocimacro

    public static boolean isVelocimacro(String vmName,
                                        String templateName)

  Checks to see if a VM exists

  Parameters:
    `vmName` - Name of the Velocimacro.
    `templateName` - Template on which to look for the Macro.
  Returns:
    True if VM by that name exists, false if not
  See Also:
    `RuntimeInstance.isVelocimacro(String, String)`

### dumpVMNamespace

    public static boolean dumpVMNamespace(String namespace)

  tells the vmFactory to dump the specified namespace. This is to support clearing the VM list when in inline-VM-local-scope mode

  Parameters:
    `namespace` - Namespace to dump.
  Returns:
    True if namespace was dumped successfully.
  See Also:
    `RuntimeInstance.dumpVMNamespace(String)`

### getString

    public static String getString(String key)

  String property accessor method to hide the configuration implementation

  Parameters:
    `key` - property key
  Returns:
    value of key or null
  See Also:
    `RuntimeInstance.getString(String)`

### getInt

    public static int getInt(String key)

  Int property accessor method to hide the configuration implementation.

  Parameters:
    `key` - Property key
  Returns:
    value
  See Also:
    `RuntimeInstance.getInt(String)`

### getInt

    public static int getInt(String key,
                             int defaultValue)

  Int property accessor method to hide the configuration implementation.

  Parameters:
    `key` - property key
    `defaultValue` - The default value.
  Returns:
    value
  See Also:
    `RuntimeInstance.getInt(String, int)`

### getBoolean

    public static boolean getBoolean(String key,
                                     boolean def)

  Boolean property accessor method to hide the configuration implementation.

  Parameters:
    `key` - property key
    `def` - The default value if property not found.
  Returns:
    value of key or default value
  See Also:
    `RuntimeInstance.getBoolean(String, boolean)`

### getConfiguration

    public static ExtendedProperties getConfiguration()

  Return the velocity runtime configuration object.

  Returns:
    ExtendedProperties configuration object which houses the velocity runtime properties.
  See Also:
    `RuntimeInstance.getConfiguration()`

### getIntrospector

    public static Introspector getIntrospector()

  Return the Introspector for this RuntimeInstance

  Returns:
    Introspector object for this runtime instance
  See Also:
    `RuntimeInstance.getIntrospector()`

### getEventCartridge

    public EventCartridge getEventCartridge()

  Returns the event handlers for the application.

  Returns:
    The event handlers for the application.
  Since:
    1.5
  See Also:
    `RuntimeInstance.getApplicationEventCartridge()`

### getApplicationAttribute

    public static Object getApplicationAttribute(Object key)

  Gets the application attribute for the given key

  Parameters:
    `key` -
  Returns:
    The application attribute for the given key.
  See Also:
    `RuntimeServices.getApplicationAttribute(Object)`, `RuntimeInstance.getApplicationAttribute(Object)`

### getUberspect

    public static Uberspect getUberspect()

  Returns the Uberspect object for this Instance.

  Returns:
    The Uberspect object for this Instance.
  See Also:
    `RuntimeServices.getUberspect()`, `RuntimeInstance.getUberspect()`

### getRuntimeInstance

    public static RuntimeInstance getRuntimeInstance()

  Deprecated. Use getRuntimeServices() instead.

  Returns:
    The RuntimeInstance used by this Singleton.

### removeDirective

    public static void removeDirective(String name)

  Remove a directive.

  Parameters:
    `name` - name of the directive.

### loadDirective

    public static void loadDirective(String directiveClass)

  Instantiates and loads the directive with some basic checks.

  Parameters:
    `directiveClass` - classname of directive to load

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2010 Apache Software Foundation. All Rights Reserved.